# Z-Wave XML

This repository is used to distribute Z-Wave XML files.
The Z-Wave XML files can be used for applications to parse
Z-Wave frames and their content.

# Prerequisites
The XML files can be used without any dependencies, but validation and generation have several dependencies:
- Python 3
- python3-xmltodict
- Jinja 2
- [jinja2-strcase](https://pypi.org/project/jinja2-strcase/)

# Validation and generation with CMake
Further prerequisites:
- CMake
- Make

Steps:
```bash
mkdir build
cd build
cmake ..
make
```

# Validation and Generation without CMake
See below for more details.

## Generating source code
The scripts located in `scripts/` can generate source code based on the templates located in
`templates/`.

To generate source code headers:

```bash
python scripts/generate_c_headers.py
```

## Validate XML
XML files can be validated if a corresponding XSD file exists.

Prerequisites:
- xmllint

Example of usage:
```bash
xmllint --noout --schema zw_manufacturers.xsd zw_manufacturers.xml
```

SPDX-License-Identifier: BSD-3-Clause

SPDX-FileCopyrightText: 2022 Z-Wave-Alliance <https://z-wavealliance.org/>
